from OpenSSL import crypto

#读取私钥
key_file=open("pr_key.bin", "rb")
key_data=key_file.read()
key=crypto.load_privatekey(crypto.FILETYPE_PEM,key_data)

#X509是一种证书格式
cert = crypto.X509()

#添加关于证书的信息
cert.get_subject().O = "XINHUA HIGH SCHOOL"
#证书对应的网站
cert.get_subject().CN = "127.0.0.1"
cert.set_issuer(cert.get_subject())

#设置证书的有效期
cert.gmtime_adj_notBefore(0)
cert.gmtime_adj_notAfter(60 * 60 * 24 * 10)

#添加秘钥
cert.set_pubkey(key)

#签名
cert.sign(key, "MD5")

#保存证书文件
data=crypto.dump_certificate(crypto.FILETYPE_PEM, cert)
with open('abc.pem','wb') as f:
    f.write(data)
